﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using wclWiFi;
using wclCommon;

namespace WiFiEvents
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private wclWiFiEvents WiFiEvents;
        private wclPowerEventsMonitor FPowerMonitor;

        internal class EventItem
        {
            public String IfaceId { get; set; }
            public String EventName { get; set; }
            public String ParamName { get; set; }
            public String ParamVal { get; set; }
        };

        public MainWindow()
        {
            InitializeComponent();
        }

        private void fmMain_Loaded(object sender, RoutedEventArgs e)
        {
            WiFiEvents = new wclWiFiEvents();

            WiFiEvents.AfterOpen += new EventHandler(Events_AfterOpen);
            WiFiEvents.BeforeClose += new EventHandler(WiFiEvents_BeforeClose);

            WiFiEvents.OnAcmAdHocNetworkStateChange += new wclWiFiAcmAdHocNetworkStateChangeEvent(WiFiEvents_OnAcmAdHocNetworkStateChange);
            WiFiEvents.OnAcmAutoconfDisabled += new wclWiFiEvent(WiFiEvents_OnAcmAutoconfDisabled);
            WiFiEvents.OnAcmAutoconfEnabled += new wclWiFiEvent(WiFiEvents_OnAcmAutoconfEnabled);
            WiFiEvents.OnAcmBackgroundScanDisabled += new wclWiFiEvent(WiFiEvents_OnAcmBackgroundScanDisabled);
            WiFiEvents.OnAcmBackgroundScanEnabled += new wclWiFiEvent(WiFiEvents_OnAcmBackgroundScanEnabled);
            WiFiEvents.OnAcmBssTypeChange += new wclWiFiAcmBssTypeChangeEvent(WiFiEvents_OnAcmBssTypeChange);
            WiFiEvents.OnAcmConnectionAttemptFail += new wclWiFiAcmConnectionEvent(WiFiEvents_OnAcmConnectionAttemptFail);
            WiFiEvents.OnAcmConnectionComplete += new wclWiFiAcmConnectionEvent(WiFiEvents_OnAcmConnectionComplete);
            WiFiEvents.OnAcmConnectionStart += new wclWiFiAcmConnectionEvent(WiFiEvents_OnAcmConnectionStart);
            WiFiEvents.OnAcmDisconnected += new wclWiFiAcmConnectionEvent(WiFiEvents_OnAcmDisconnected);
            WiFiEvents.OnAcmDisconnecting += new wclWiFiAcmConnectionEvent(WiFiEvents_OnAcmDisconnecting);
            WiFiEvents.OnAcmFilterListChange += new wclWiFiEvent(WiFiEvents_OnAcmFilterListChange);
            WiFiEvents.OnAcmInterfaceArrival += new wclWiFiEvent(WiFiEvents_OnAcmInterfaceArrival);
            WiFiEvents.OnAcmInterfaceRemoval += new wclWiFiEvent(WiFiEvents_OnAcmInterfaceRemoval);
            WiFiEvents.OnAcmNetworkAvailable += new wclWiFiEvent(WiFiEvents_OnAcmNetworkAvailable);
            WiFiEvents.OnAcmNetworkNotAvailable += new wclWiFiEvent(WiFiEvents_OnAcmNetworkNotAvailable);
            WiFiEvents.OnAcmOperationalStateChange += new wclWiFiEvent(WiFiEvents_OnAcmOperationalStateChange);
            WiFiEvents.OnAcmPowerSettingChange += new wclWiFiAcmPowerSettingChangeEvent(WiFiEvents_OnAcmPowerSettingChange);
            WiFiEvents.OnAcmProfileBlocked += new wclWiFiEvent(WiFiEvents_OnAcmProfileBlocked);
            WiFiEvents.OnAcmProfileChange += new wclWiFiEvent(WiFiEvents_OnAcmProfileChange);
            WiFiEvents.OnAcmProfileNameChange += new wclWiFiAcmProfileNameChangeEvent(WiFiEvents_OnAcmProfileNameChange);
            WiFiEvents.OnAcmProfilesExhausted += new wclWiFiEvent(WiFiEvents_OnAcmProfilesExhausted);
            WiFiEvents.OnAcmProfileUnblocked += new wclWiFiEvent(WiFiEvents_OnAcmProfileUnblocked);
            WiFiEvents.OnAcmScanComplete += new wclWiFiEvent(WiFiEvents_OnAcmScanComplete);
            WiFiEvents.OnAcmScanFail += new wclWiFiAcmScanFailEvent(WiFiEvents_OnAcmScanFail);
            WiFiEvents.OnAcmScanListRefresh += new wclWiFiEvent(WiFiEvents_OnAcmScanListRefresh);
            WiFiEvents.OnAcmScreenPowerChange += new wclWiFiAcmScreenPowerChangeEvent(WiFiEvents_OnAcmScreenPowerChange);

            WiFiEvents.OnHostedNetworkPeerStateChange += new wclWiFiHostedNetworkPeerStateChangeEvent(WiFiEvents_OnHostedNetworkPeerStateChange);
            WiFiEvents.OnHostedNetworkRadioStateChange += new wclWiFiHostedNetworkRadioStateChangeEvent(WiFiEvents_OnHostedNetworkRadioStateChange);
            WiFiEvents.OnHostedNetworkStateChange += new wclWiFiHostedNetworkStateChangeEvent(WiFiEvents_OnHostedNetworkStateChange);

            WiFiEvents.OnMsmAdapterOperationModeChange += new wclWiFiMsmAdapterOperationModeChangeEvent(WiFiEvents_OnMsmAdapterOperationModeChange);
            WiFiEvents.OnMsmAdapterRemoval += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmAdapterRemoval);
            WiFiEvents.OnMsmAssociated += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmAssociated);
            WiFiEvents.OnMsmAssociating += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmAssociating);
            WiFiEvents.OnMsmAuthenticating += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmAuthenticating);
            WiFiEvents.OnMsmConnected += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmConnected);
            WiFiEvents.OnMsmDisassociating += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmDisassociating);
            WiFiEvents.OnMsmDisconnected += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmDisconnected);
            WiFiEvents.OnMsmPeerJoin += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmPeerJoin);
            WiFiEvents.OnMsmPeerLeave += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmPeerLeave);
            WiFiEvents.OnMsmRadioStateChange += new wclWiFiMsmRadioStateChangeEvent(WiFiEvents_OnMsmRadioStateChange);
            WiFiEvents.OnMsmRoamingEnd += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmRoamingEnd);
            WiFiEvents.OnMsmRoamingStart += new wclWiFiMsmConnectionEvent(WiFiEvents_OnMsmRoamingStart);
            WiFiEvents.OnMsmSignalQualityChange += new wclWiFiMsmSignalQualityChangeEvent(WiFiEvents_OnMsmSignalQualityChange);
            WiFiEvents.OnMsmLinkDegraded += new wclWiFiEvent(WiFiEvents_OnMsmLinkDegraded);
            WiFiEvents.OnMsmLinkImproved += new wclWiFiEvent(WiFiEvents_OnMsmLinkImproved);

            WiFiEvents.OnOneXAuthRestarted += new wclWiFiOneXAuthRestartedEvent(WiFiEvents_OnOneXAuthRestarted);
            WiFiEvents.OnOneXAuthUpdate += new wclWiFiOneXAuthUpdateEvent(WiFiEvents_OnOneXAuthUpdate);

            WiFiEvents.OnIpChanged += new wclWiFiIpChangedEvent(WiFiEvents_OnIpChanged);

            FPowerMonitor = new wclPowerEventsMonitor();
            FPowerMonitor.OnPowerStateChanged += new wclPowerStateChangedEvent(FPowerMonitor_OnPowerStateChanged);
            FPowerMonitor.Open();
        }

        void WiFiEvents_OnMsmLinkImproved(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "MsmLinkImproved", "", "");
        }

        void WiFiEvents_OnMsmLinkDegraded(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "MsmLinkDegraded", "", "");
        }

        void WiFiEvents_OnOneXAuthUpdate(object Sender, Guid IfaceId, wclWiFiOneXStatusUpdate State)
        {
            String Str;

            switch (State.Status.Status)
            {
                case wclWiFiOneXAuthStatus.oxAuthNotStarted:
                    Str = "oxAuthNotStarted";
                    break;
                case wclWiFiOneXAuthStatus.oxAuthInProgress:
                    Str = "oxAuthInProgress";
                    break;
                case wclWiFiOneXAuthStatus.oxAuthNoAuthenticatorFound:
                    Str = "oxAuthNoAuthenticatorFound";
                    break;
                case wclWiFiOneXAuthStatus.oxAuthSuccess:
                    Str = "oxAuthSuccess";
                    break;
                case wclWiFiOneXAuthStatus.oxAuthFailure:
                    Str = "oxAuthFailure";
                    break;
                case wclWiFiOneXAuthStatus.oxAuthInvalid:
                    Str = "oxAuthInvalid";
                    break;
                default:
                    Str = "";
                    break;
            }
            TraceEvent(IfaceId, "OneXAuthUpdate", "Status", Str);
            TraceEvent(Guid.Empty, "", "Status.Reason", "0x" + State.Status.Reason.ToString("X8"));
            TraceEvent(Guid.Empty, "", "Status.Error", "0x" + State.Status.Error.ToString("X8"));

            switch (State.BackendSupport)
            {
                case wclWiFiOneXEapMethodBackendSupport.oxEapMethodBackendSupportUnknown:
                    Str = "oxEapMethodBackendSupportUnknown";
                    break;
                case wclWiFiOneXEapMethodBackendSupport.oxEapMethodBackendSupported:
                    Str = "oxEapMethodBackendSupported";
                    break;
                case wclWiFiOneXEapMethodBackendSupport.oxEapMethodBackendUnsupported:
                    Str = "oxEapMethodBackendUnsupported";
                    break;
                default:
                    Str = "";
                    break;
            }
            TraceEvent(Guid.Empty, "", "BackendSupport", Str);

            if (State.BackendEngaged)
                TraceEvent(Guid.Empty, "", "BackendEngaged", "True");
            else
                TraceEvent(Guid.Empty, "", "BackendEngaged", "False");

            if (State.AuthParams.UpdatePending)
                TraceEvent(Guid.Empty, "", "AuthParams.UpdatePending", "True");
            else
                TraceEvent(Guid.Empty, "", "AuthParams.UpdatePending", "False");

            switch (State.AuthParams.Profile.SupplicantMode)
            {
                case wclWiFiOneXSupplicantMode.oxSupplicantModeInhibitTransmission:
                    Str = "oxSupplicantModeInhibitTransmission";
                    break;
                case wclWiFiOneXSupplicantMode.oxSupplicantModeLearn:
                    Str = "oxSupplicantModeLearn";
                    break;
                case wclWiFiOneXSupplicantMode.oxSupplicantModeCompliant:
                    Str = "oxSupplicantModeCompliant";
                    break;
                case wclWiFiOneXSupplicantMode.oxSupplicantModeInvalid:
                    Str = "oxSupplicantModeInvalid";
                    break;
                default:
                    Str = "";
                    break;
            }
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.SupplicantMode", Str);

            switch (State.AuthParams.Profile.AuthMode)
            {
                case wclWiFiOnexXAuthMode.oxAuthModeMachineOrUser:
                    Str = "oxAuthModeMachineOrUser";
                    break;
                case wclWiFiOnexXAuthMode.oxAuthModeMachineOnly:
                    Str = "oxAuthModeMachineOnly";
                    break;
                case wclWiFiOnexXAuthMode.oxAuthModeUserOnly:
                    Str = "oxAuthModeUserOnly";
                    break;
                case wclWiFiOnexXAuthMode.oxAuthModeGuest:
                    Str = "oxAuthModeGuest";
                    break;
                case wclWiFiOnexXAuthMode.oxAuthModeUnspecified:
                    Str = "oxAuthModeUnspecified";
                    break;
                case wclWiFiOnexXAuthMode.oxAuthModeInvalid:
                    Str = "oxAuthModeInvalid";
                    break;
                default:
                    Str = "";
                    break;
            }
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.AuthMode", Str);

            TraceEvent(Guid.Empty, "", "AuthParams.Profile.HeldPeriod", State.AuthParams.Profile.HeldPeriod.ToString());
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.AuthPeriod", State.AuthParams.Profile.AuthPeriod.ToString());
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.StartPeriod", State.AuthParams.Profile.StartPeriod.ToString());
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.MaxStart", State.AuthParams.Profile.MaxStart.ToString());
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.MaxAuthFailures", State.AuthParams.Profile.MaxAuthFailures.ToString());
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.NetworkAuthTimeout", State.AuthParams.Profile.NetworkAuthTimeout.ToString());
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.NetworkAuthWithUITimeout", State.AuthParams.Profile.NetworkAuthWithUITimeout.ToString());

            if (State.AuthParams.Profile.AllowLogonDialogs)
                TraceEvent(Guid.Empty, "", "AuthParams.Profile.AllowLogonDialogs", "True");
            else
                TraceEvent(Guid.Empty, "", "AuthParams.Profile.AllowLogonDialogs", "False");

            if (State.AuthParams.Profile.UserBasedVLan)
                TraceEvent(Guid.Empty, "", "AuthParams.Profile.UserBasedVLan", "True");
            else
                TraceEvent(Guid.Empty, "", "AuthParams.Profile.UserBasedVLan", "False");

            switch (State.AuthParams.AuthIdentity)
            {
                case wclWiFiOneXAuthIdentity.oxAuthIdentityNone:
                    Str = "";
                    break;
                case wclWiFiOneXAuthIdentity.oxAuthIdentityMachine:
                    Str = "";
                    break;
                case wclWiFiOneXAuthIdentity.oxAuthIdentityUser:
                    Str = "";
                    break;
                case wclWiFiOneXAuthIdentity.oxAuthIdentityExplicitUser:
                    Str = "";
                    break;
                case wclWiFiOneXAuthIdentity.oxAuthIdentityGuest:
                    Str = "";
                    break;
                case wclWiFiOneXAuthIdentity.oxAuthIdentityInvalid:
                    Str = "";
                    break;
                case wclWiFiOneXAuthIdentity.oxAuthIdentityUnknown:
                    Str = "";
                    break;
                default:
                    Str = "";
                    break;
            }
            TraceEvent(Guid.Empty, "", "AuthParams.AuthIdentity", Str);

            switch (State.AuthParams.QuarantineState)
            {
                case wclWiFiIsolationState.isUnknonw:
                    Str = "isUnknonw";
                    break;
                case wclWiFiIsolationState.isNotRestricted:
                    Str = "isNotRestricted";
                    break;
                case wclWiFiIsolationState.isInProbation:
                    Str = "isInProbation";
                    break;
                case wclWiFiIsolationState.isRestrictedAccess:
                    Str = "isRestrictedAccess";
                    break;
                case wclWiFiIsolationState.isInvalid:
                    Str = "isInvalid";
                    break;
                default:
                    Str = "";
                    break;
            }
            TraceEvent(Guid.Empty, "", "AuthParams.QuarantineState", Str);

            TraceEvent(Guid.Empty, "", "AuthParams.SessiondId", State.AuthParams.SessiondId.ToString());
            TraceEvent(Guid.Empty, "", "AuthParams.Identity", State.AuthParams.Identity);
            TraceEvent(Guid.Empty, "", "AuthParams.UserName", State.AuthParams.UserName);
            TraceEvent(Guid.Empty, "", "AuthParams.Domain", State.AuthParams.Domain);

            TraceEvent(Guid.Empty, "", "EapError.Error", "0x" + State.EapError.Error.ToString("X8"));

            TraceEvent(Guid.Empty, "", "EapError.MethodType.EapType.EapType", State.EapError.MethodType.EapType.EapType.ToString());
            TraceEvent(Guid.Empty, "", "EapError.MethodType.EapType.VendorId", State.EapError.MethodType.EapType.VendorId.ToString());
            TraceEvent(Guid.Empty, "", "EapError.MethodType.EapType.VendorType", State.EapError.MethodType.EapType.VendorType.ToString());

            TraceEvent(Guid.Empty, "", "EapError.MethodType.AuthorId", State.EapError.MethodType.AuthorId.ToString());

            TraceEvent(Guid.Empty, "", "EapError.Reason", "0x" + State.EapError.Reason.ToString("X8"));
            TraceEvent(Guid.Empty, "", "EapError.RootCauseGuid", State.EapError.RootCauseGuid.ToString());
            TraceEvent(Guid.Empty, "", "EapError.RepairGuid", State.EapError.RepairGuid.ToString());
            TraceEvent(Guid.Empty, "", "EapError.HelpLinkGuid", State.EapError.HelpLinkGuid.ToString());
            TraceEvent(Guid.Empty, "", "EapError.RootCauseString", State.EapError.RootCauseString);
            TraceEvent(Guid.Empty, "", "EapError.RepairString", State.EapError.RepairString);
        }

        void WiFiEvents_OnIpChanged(object Sender, Guid IfaceId, wclWiFiIpSettings Old, wclWiFiIpSettings New)
        {
            TraceEvent(IfaceId, "IP changed", "Old address", Old.Address);
            TraceEvent(Guid.Empty, "IP changed", "New address", New.Address);
        }

        void FPowerMonitor_OnPowerStateChanged(object Sender, wclPowerState State)
        {
            switch (State)
            {
                case wclPowerState.psResumeAutomatic:
                    TraceEvent(Guid.Empty, "Power", "State", "psResumeAutomatic");
                    break;
                case wclPowerState.psResume:
                    TraceEvent(Guid.Empty, "Power", "State", "psResume");
                    break;
                case wclPowerState.psSuspend:
                    TraceEvent(Guid.Empty, "Power", "State", "psSuspend");
                    break;
                case wclPowerState.psUnknown:
                    TraceEvent(Guid.Empty, "Power", "State", "psUnknown");
                    break;
            }
        }

        void WiFiEvents_OnAcmOperationalStateChange(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmOperationalStateChange", "", "");
        }

        void WiFiEvents_OnAcmNetworkNotAvailable(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmNetworkNotAvailable", "", "");
        }

        void WiFiEvents_OnAcmNetworkAvailable(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmNetworkAvailable", "", "");
        }

        void WiFiEvents_OnAcmInterfaceRemoval(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmInterfaceRemoval", "", "");
        }

        void WiFiEvents_OnAcmInterfaceArrival(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmInterfaceArrival", "", "");
        }

        void WiFiEvents_OnAcmFilterListChange(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmFilterListChange", "", "");
        }

        void WiFiEvents_OnAcmDisconnecting(object Sender, Guid IfaceId, wclWiFiAcmConnectionEventData Data)
        {
            TraceAcmConnectionEvent(IfaceId, "AcmDisconnecting", Data);
        }

        void WiFiEvents_OnAcmDisconnected(object Sender, Guid IfaceId, wclWiFiAcmConnectionEventData Data)
        {
            TraceAcmConnectionEvent(IfaceId, "AcmDisconnected", Data);
        }

        void WiFiEvents_OnAcmConnectionStart(object Sender, Guid IfaceId, wclWiFiAcmConnectionEventData Data)
        {
            TraceAcmConnectionEvent(IfaceId, "AcmConnectionStart", Data);
        }

        void WiFiEvents_OnAcmConnectionComplete(object Sender, Guid IfaceId, wclWiFiAcmConnectionEventData Data)
        {
            TraceAcmConnectionEvent(IfaceId, "AcmConnectionComplete", Data);
        }

        void WiFiEvents_OnAcmConnectionAttemptFail(object Sender, Guid IfaceId, wclWiFiAcmConnectionEventData Data)
        {
            TraceAcmConnectionEvent(IfaceId, "AcmConnectionAttemptFail", Data);
        }

        void WiFiEvents_OnAcmPowerSettingChange(object Sender, Guid IfaceId, wclWiFiPowerSetting Setting)
        {
            TraceEvent(IfaceId, "AcmOperationalStateChange", "Setting", Setting.ToString());
        }

        void WiFiEvents_OnAcmProfileBlocked(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmProfileBlocked", "", "");
        }

        void WiFiEvents_OnAcmProfileChange(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmProfileChange", "", "");
        }

        void WiFiEvents_OnAcmProfileNameChange(object Sender, Guid IfaceId, string OldName, string NewName)
        {
            TraceEvent(IfaceId, "AcmProfileNameChange", "OldName", OldName);
            TraceEvent(Guid.Empty, "", "NewName", NewName);
        }

        void WiFiEvents_OnAcmProfilesExhausted(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmProfilesExhausted", "", "");
        }

        void WiFiEvents_OnAcmProfileUnblocked(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmProfileUnblocked", "", "");
        }

        void WiFiEvents_OnAcmScanComplete(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmScanComplete", "", "");
        }

        void WiFiEvents_OnAcmScanFail(object Sender, Guid IfaceId, int Reason)
        {
            TraceEvent(IfaceId, "AcmScanFail", "Reason", Reason.ToString());
        }

        void WiFiEvents_OnAcmScanListRefresh(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmScanListRefresh", "", "");
        }

        void WiFiEvents_OnAcmScreenPowerChange(object Sender, Guid IfaceId, bool SwitchedOn)
        {
            TraceEvent(IfaceId, "AcmScreenPowerChange", "SwitchedOn", SwitchedOn.ToString());
        }

        void WiFiEvents_OnHostedNetworkPeerStateChange(object Sender, Guid IfaceId, wclWiFiHostedNetworkPeerState OldState, wclWiFiHostedNetworkPeerState NewState, int Reason)
        {
            TraceEvent(IfaceId, "HostedNetworkPeerStateChange", "Old MAC", OldState.Mac);
            TraceEvent(Guid.Empty, "", "Old authentication state", OldState.AuthState.ToString());
            TraceEvent(Guid.Empty, "", "New MAC", NewState.Mac);
            TraceEvent(Guid.Empty, "", "New authentication state", NewState.AuthState.ToString());
            TraceEvent(Guid.Empty, "", "Reason 0x", Reason.ToString("X8"));
        }

        void WiFiEvents_OnHostedNetworkRadioStateChange(object Sender, Guid IfaceId, wclWiFiRadioState SoftwareState, wclWiFiRadioState HardwareState)
        {
            TraceEvent(IfaceId, "HostedNetworkRadioStateChange", "Software state", SoftwareState.ToString());
            TraceEvent(Guid.Empty, "", "Hardware state", HardwareState.ToString());
        }

        void WiFiEvents_OnHostedNetworkStateChange(object Sender, Guid IfaceId, wclWiFiHostedNetworkState OldState, wclWiFiHostedNetworkState NewState, int Reason)
        {
            TraceEvent(IfaceId, "HostedNetworkStateChange", "Old state", OldState.ToString());
            TraceEvent(Guid.Empty, "", "New state", NewState.ToString());
            TraceEvent(Guid.Empty, "", "Reason 0x", Reason.ToString("X8"));
        }

        void WiFiEvents_OnMsmAdapterOperationModeChange(object Sender, Guid IfaceId, wclWiFiOperationMode Mode)
        {
            TraceEvent(IfaceId, "MsmAdapterOperationModeChange", "Mode", Mode.ToString());
        }

        void WiFiEvents_OnMsmAdapterRemoval(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmAdapterRemoval", Data);
        }

        void WiFiEvents_OnMsmAssociated(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmAssociated", Data);
        }

        void WiFiEvents_OnMsmAssociating(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmAssociating", Data);
        }

        void WiFiEvents_OnMsmAuthenticating(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmAuthenticating", Data);
        }

        void WiFiEvents_OnMsmConnected(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmConnected", Data);
        }

        void WiFiEvents_OnMsmDisassociating(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmDisassociating", Data);
        }

        void WiFiEvents_OnMsmDisconnected(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmDisconnected", Data);
        }

        void WiFiEvents_OnMsmPeerJoin(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmPeerJoin", Data);
        }

        void WiFiEvents_OnMsmPeerLeave(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmPeerLeave", Data);
        }

        void WiFiEvents_OnMsmRadioStateChange(object Sender, Guid IfaceId, wclWiFiPhyRadioState State)
        {
            TraceEvent(IfaceId, "MsmRadioStateChange", "PHY", State.Phy.ToString());
            TraceEvent(Guid.Empty, "", "Software state", State.SoftwareState.ToString());
            TraceEvent(Guid.Empty, "", "Hardware state", State.HardwareState.ToString());
        }

        void WiFiEvents_OnMsmRoamingEnd(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmRoamingEnd", Data);
        }

        void WiFiEvents_OnMsmRoamingStart(object Sender, Guid IfaceId, wclWiFiMsmConnectionEventData Data)
        {
            TraceMsmConnectionEvent(IfaceId, "MsmRoamingStart", Data);
        }

        void WiFiEvents_OnMsmSignalQualityChange(object Sender, Guid IfaceId, uint Quality)
        {
            TraceEvent(IfaceId, "MsmSignalQualityChange", "Quality", Quality.ToString());
        }

        void WiFiEvents_OnOneXAuthRestarted(object Sender, Guid IfaceId, int Reason)
        {
            TraceEvent(IfaceId, "OneXAuthRestarted", "Reason", Reason.ToString());
        }

        private void TraceMsmConnectionEvent(Guid IfaceId, String EventName, wclWiFiMsmConnectionEventData Data)
        {
            TraceEvent(IfaceId, EventName, "ConnectionMode", Data.ConnectionMode.ToString());
            TraceEvent(Guid.Empty, "", "Profile name", Data.ProfileName);
            TraceEvent(Guid.Empty, "", "SSID", Data.Ssid);
            TraceEvent(Guid.Empty, "", "BSS type", Data.BssType.ToString());
            TraceEvent(Guid.Empty, "", "MAC", Data.Mac);
            TraceEvent(Guid.Empty, "", "Security enabled", Data.SecurityEnabled.ToString());
            TraceEvent(Guid.Empty, "", "First peer", Data.FirstPeer.ToString());
            TraceEvent(Guid.Empty, "", "Last peer", Data.LastPeer.ToString());
            TraceEvent(Guid.Empty, "", "Reason 0x", Data.Reason.ToString("X8"));
        }

        private void TraceAcmConnectionEvent(Guid IfaceId, String EventName, wclWiFiAcmConnectionEventData Data)
        {
            TraceEvent(IfaceId, EventName, "ConnectionMode", Data.ConnectionMode.ToString());
            TraceEvent(Guid.Empty, "", "Profile name", Data.ProfileName);
            TraceEvent(Guid.Empty, "", "SSID", Data.Ssid);
            TraceEvent(Guid.Empty, "", "BSS type", Data.BssType.ToString());
            TraceEvent(Guid.Empty, "", "Security enabled", Data.SecurityEnabled.ToString());
            TraceEvent(Guid.Empty, "", "Reason 0x", Data.Reason.ToString("X8"));
            TraceEvent(Guid.Empty, "", "Flags", Data.Flags.ToString());
            TraceEvent(Guid.Empty, "", "Profile XML", Data.ProfileXml);
        }

        void WiFiEvents_OnAcmBssTypeChange(object Sender, Guid IfaceId, wclWiFiBssType BssType)
        {
            TraceEvent(IfaceId, "AcmBssTypeChange", "BSS type", BssType.ToString());
        }

        void WiFiEvents_OnAcmBackgroundScanEnabled(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmBackgroundScanEnabled", "", "");
        }

        void WiFiEvents_OnAcmBackgroundScanDisabled(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmBackgroundScanDisabled", "", "");
        }

        void WiFiEvents_OnAcmAutoconfEnabled(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmAutoconfEnabled", "", "");
        }

        void WiFiEvents_OnAcmAutoconfDisabled(object Sender, Guid IfaceId)
        {
            TraceEvent(IfaceId, "AcmAutoconfDisabled", "", "");
        }

        void WiFiEvents_OnAcmAdHocNetworkStateChange(object Sender, Guid IfaceId, wclWiFiAdHocNetworkState State)
        {
            TraceEvent(IfaceId, "AcmAdHocNetworkStateChange", "State", State.ToString());
        }

        void WiFiEvents_BeforeClose(object sender, EventArgs e)
        {
            TraceEvent(Guid.Empty, "BeforeClose", "", "");
        }

        void Events_AfterOpen(object sender, EventArgs e)
        {
            TraceEvent(Guid.Empty, "AfterOpen", "", "");
        }

        private void fmMain_Closed(object sender, EventArgs e)
        {
            WiFiEvents.Close();

            FPowerMonitor.Close();
        }

        private void btOpen_Click(object sender, RoutedEventArgs e)
        {
            ShowResult(WiFiEvents.Open());
        }

        private void btClose_Click(object sender, RoutedEventArgs e)
        {
            ShowResult(WiFiEvents.Close());
        }

        private void ShowResult(Int32 Res)
        {
            if (Res != wclErrors.WCL_E_SUCCESS)
                MessageBox.Show("Error: 0x" + Res.ToString("X8"));
        }

        private void btClear_Click(object sender, RoutedEventArgs e)
        {
            lvEvents.Items.Clear();
        }

        private void TraceEvent(Guid Iface, String eventName, String paramName, String paramValue)
        {
            String Id;
            if (Iface == Guid.Empty)
                Id = "";
            else
                Id = Iface.ToString();

            lvEvents.Items.Add(new EventItem{
                IfaceId = Id,
                EventName = eventName,
                ParamName = paramName,
                ParamVal = paramValue
            });
        }
    }
}
