Public Class fmMain
    Private WithEvents wclNetworkListManager As wclWiFi.wclNetworkListManager

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbNetworkType.SelectedIndex = 2
        cbCategory.SelectedIndex = 0

        wclNetworkListManager = New wclWiFi.wclNetworkListManager()
    End Sub

    Private Sub wclNetworkListManager_AfterOpen(ByVal sender As Object, ByVal e As System.EventArgs) Handles wclNetworkListManager.AfterOpen
        lbEvents.Items.Add("AfterOpen")
    End Sub

    Private Sub wclNetworkListManager_BeforeClose(ByVal sender As Object, ByVal e As System.EventArgs) Handles wclNetworkListManager.BeforeClose
        lbEvents.Items.Add("BeforeClose")
    End Sub

    Private Sub wclNetworkListManager_OnConnectionConnectivityChanged(ByVal Sender As Object, ByVal ConnectionId As System.Guid, ByVal Connectivity As wclWiFi.wclNlmConnectivity) Handles wclNetworkListManager.OnConnectionConnectivityChanged
        lbEvents.Items.Add("Connection: " + ConnectionId.ToString() + " connectivity changed: " + Connectivity.ToString())
    End Sub

    Private Sub wclNetworkListManager_OnConnectionPropertyChanged(ByVal Sender As Object, ByVal ConnectionId As System.Guid, ByVal Prop As wclWiFi.wclNlmConnectionProperty) Handles wclNetworkListManager.OnConnectionPropertyChanged
        lbEvents.Items.Add("Connection: " + ConnectionId.ToString() + " property changed: " + Prop.ToString())
    End Sub

    Private Sub wclNetworkListManager_OnConnectivityChanged(ByVal Sender As Object, ByVal Connectivity As wclWiFi.wclNlmConnectivity) Handles wclNetworkListManager.OnConnectivityChanged
        lbEvents.Items.Add("Connectivity changed: " + Connectivity.ToString())
    End Sub

    Private Sub wclNetworkListManager_OnNetworkAdded(ByVal Sender As Object, ByVal NetworkId As System.Guid) Handles wclNetworkListManager.OnNetworkAdded
        lbEvents.Items.Add("Network added: " + NetworkId.ToString())
    End Sub

    Private Sub wclNetworkListManager_OnNetworkConnectivityChanged(ByVal Sender As Object, ByVal NetworkId As System.Guid, ByVal Connectivity As wclWiFi.wclNlmConnectivity) Handles wclNetworkListManager.OnNetworkConnectivityChanged
        lbEvents.Items.Add("Network " + NetworkId.ToString() + " connectivity changed: " + Connectivity.ToString())
    End Sub

    Private Sub wclNetworkListManager_OnNetworkDeleted(ByVal Sender As Object, ByVal NetworkId As System.Guid) Handles wclNetworkListManager.OnNetworkDeleted
        lbEvents.Items.Add("Network deleted: " + NetworkId.ToString())
    End Sub

    Private Sub wclNetworkListManager_OnNetworkPropertyChanged(ByVal Sender As Object, ByVal NetworkId As System.Guid, ByVal Change As wclWiFi.wclNlmNetworkPropertyChange) Handles wclNetworkListManager.OnNetworkPropertyChanged
        lbEvents.Items.Add("Network " + NetworkId.ToString() + " property changed: " + Change.ToString())
    End Sub

    Private Sub fmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        wclNetworkListManager.Close()
    End Sub

    Private Sub btClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btClear.Click
        lbEvents.Items.Clear()
    End Sub

    Private Sub btOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btOpen.Click
        ShowError(wclNetworkListManager.Open())
    End Sub

    Private Sub btClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btClose.Click
        ShowError(wclNetworkListManager.Close())
    End Sub

    Private Function ShowError(ByVal Err As Int32) As Boolean
        If Err <> wclCommon.wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Error: 0x" + Err.ToString("X8"))
            Return True
        End If

        Return False
    End Function

    Private Function DecodeConnectivity(ByVal Connectivity As wclWiFi.wclNetworkListManager) As String
        Return Connectivity.ToString()
    End Function

    Private Sub btIsConnected_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btIsConnected.Click
        Dim Connected As Boolean
        If Not ShowError(wclNetworkListManager.GetConnected(Connected)) Then
            If Connected Then
                MessageBox.Show("Connected")
            Else
                MessageBox.Show("NOT Connected")
            End If
        End If
    End Sub

    Private Sub btIsConnectedToInternet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btIsConnectedToInternet.Click
        Dim Connected As Boolean
        If Not ShowError(wclNetworkListManager.GetConnectedToInternet(Connected)) Then
            If Connected Then
                MessageBox.Show("Connected")
            Else
                MessageBox.Show("NOT Connected")
            End If
        End If
    End Sub

    Private Sub btConnectivity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btConnectivity.Click
        Dim Connectivity As wclWiFi.wclNlmConnectivity
        If Not ShowError(wclNetworkListManager.GetConnectivity(Connectivity)) Then
            MessageBox.Show("Connectivity: " + Connectivity.ToString())
        End If
    End Sub

    Private Sub btEnumNetworks_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btEnumNetworks.Click
        lvNetworks.Items.Clear()

        Dim Flag As wclWiFi.wclNlmEnumNetwork = CType(cbNetworkType.SelectedIndex, wclWiFi.wclNlmEnumNetwork)
        Dim Networks() As wclWiFi.wclNlmNetwork = Nothing
        Dim Res As Int32 = wclNetworkListManager.GetNetworks(Flag, Networks)

        Try
            If Not ShowError(Res) Then
                Dim i As Integer
                For i = 0 To Networks.Length - 1
                    Dim Network As wclWiFi.wclNlmNetwork = Networks(i)
                    Dim Item As ListViewItem = lvNetworks.Items.Add("")

                    Dim Id As Guid
                    Res = Network.GetNetworkId(Id)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.Text = Id.ToString()
                    Else
                        Item.Text = "Error: 0x" + Res.ToString("X8")
                    End If

                    Dim Category As wclWiFi.wclNlmNetworkCategory
                    Res = Network.GetCategory(Category)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(Category.ToString())
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If

                    Dim Connectivity As wclWiFi.wclNlmConnectivity
                    Res = Network.GetConnectivity(Connectivity)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(Connectivity.ToString())
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If

                    Dim Description As String = ""
                    Res = Network.GetDescription(Description)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(Description)
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If

                    Dim Domain As wclWiFi.wclNlmDomainType
                    Res = Network.GetDomainType(Domain)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(Domain.ToString())
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If

                    Dim AName As String = ""
                    Res = Network.GetName(AName)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(AName)
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If

                    Dim CreationDateTime As DateTime
                    Dim ConnectedDateTime As DateTime
                    Res = Network.GetTimeCreatedAndConnected(CreationDateTime, ConnectedDateTime)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(CreationDateTime.ToString())
                        Item.SubItems.Add(ConnectedDateTime.ToString())
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If

                    Dim Connected As Boolean
                    Res = Network.GetConnected(Connected)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(Connected.ToString())
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If

                    Res = Network.GetConnectedToInternet(Connected)
                    If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                        Item.SubItems.Add(Connected.ToString())
                    Else
                        Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                    End If
                Next i
            End If
        Finally
            Networks = Nothing
        End Try
    End Sub

    Private Sub btRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btRefresh.Click
        If lvNetworks.SelectedItems.Count = 0 Then
            MessageBox.Show("Select network")
            Return
        End If

        Dim Network As wclWiFi.wclNlmNetwork = Nothing
        Dim Item As ListViewItem = lvNetworks.SelectedItems(0)
        Dim Id As Guid = New Guid(Item.SubItems(0).Text)
        If Not ShowError(wclNetworkListManager.GetNetwork(Id, Network)) Then
            Try
                Dim Category As wclWiFi.wclNlmNetworkCategory
                Dim Res As Integer = Network.GetCategory(Category)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(1).Text = Category.ToString()
                Else
                    Item.SubItems(1).Text = "Error: 0x" + Res.ToString("X8")
                End If

                Dim Connectivity As wclWiFi.wclNlmConnectivity
                Res = Network.GetConnectivity(Connectivity)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(2).Text = Connectivity.ToString()
                Else
                    Item.SubItems(2).Text = "Error: 0x" + Res.ToString("X8")
                End If

                Dim Description As String = ""
                Res = Network.GetDescription(Description)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(3).Text = Description
                Else
                    Item.SubItems(3).Text = "Error: 0x" + Res.ToString("X8")
                End If

                Dim Domain As wclWiFi.wclNlmDomainType
                Res = Network.GetDomainType(Domain)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(4).Text = Domain.ToString()
                Else
                    Item.SubItems(4).Text = "Error: 0x" + Res.ToString("X8")
                End If

                Dim AName As String = ""
                Res = Network.GetName(AName)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(5).Text = AName
                Else
                    Item.SubItems(5).Text = "Error: 0x" + Res.ToString("X8")
                End If

                Dim CreationDateTime As DateTime
                Dim ConnectedDateTime As DateTime
                Res = Network.GetTimeCreatedAndConnected(CreationDateTime, ConnectedDateTime)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(6).Text = CreationDateTime.ToString()
                    Item.SubItems(7).Text = ConnectedDateTime.ToString()
                Else
                    Item.SubItems(6).Text = "Error: 0x" + Res.ToString("X8")
                    Item.SubItems(7).Text = "Error: 0x" + Res.ToString("X8")
                End If

                Dim Connected As Boolean
                Res = Network.GetConnected(Connected)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(8).Text = Connected.ToString()
                Else
                    Item.SubItems(8).Text = "Error: 0x" + Res.ToString("X8")
                End If

                Res = Network.GetConnectedToInternet(Connected)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems(9).Text = Connected.ToString()
                Else
                    Item.SubItems(9).Text = "Error: 0x" + Res.ToString("X8")
                End If
            Finally
                Network = Nothing
            End Try
        End If
    End Sub

    Private Sub btSetName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSetName.Click
        If lvNetworks.SelectedItems.Count = 0 Then
            MessageBox.Show("Select network")
            Return
        End If

        Dim Network As wclWiFi.wclNlmNetwork = Nothing
        Dim Res As Integer = wclNetworkListManager.GetNetwork(New Guid(lvNetworks.SelectedItems(0).SubItems(0).Text), Network)
        If Not ShowError(Res) Then
            If ShowError(Network.SetName(edNewNameOrDescription.Text)) Then
                MessageBox.Show("Admin privilegies required")

                Network = Nothing
            End If
        End If
    End Sub

    Private Sub btGetNetworkConnections_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetNetworkConnections.Click
        If lvNetworks.SelectedItems.Count = 0 Then
            MessageBox.Show("Select network")
            Return
        End If

        Dim Network As wclWiFi.wclNlmNetwork = Nothing
        Dim Res As Integer = wclNetworkListManager.GetNetwork(New Guid(lvNetworks.SelectedItems(0).SubItems(0).Text), Network)
        If Not ShowError(Res) Then
            Try
                Dim Connections() As wclWiFi.wclNlmConnection = Nothing
                If Not ShowError(Network.GetConnections(Connections)) Then
                    ShowConnections(Connections)
                End If
            Finally
                Network = Nothing
            End Try
        End If
    End Sub

    Private Sub btSetDescription_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSetDescription.Click
        If lvNetworks.SelectedItems.Count = 0 Then
            MessageBox.Show("Select network")
            Return
        End If

        Dim Network As wclWiFi.wclNlmNetwork = Nothing
        Dim Res As Integer = wclNetworkListManager.GetNetwork(New Guid(lvNetworks.SelectedItems(0).SubItems(0).Text), Network)
        If Not ShowError(Res) Then
            If ShowError(Network.SetDescription(edNewNameOrDescription.Text)) Then
                MessageBox.Show("Admin privilegies required")

                Network = Nothing
            End If
        End If
    End Sub

    Private Sub btSetCategory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSetCategory.Click
        If lvNetworks.SelectedItems.Count = 0 Then
            MessageBox.Show("Select network")
            Return
        End If

        Dim Network As wclWiFi.wclNlmNetwork = Nothing
        Dim Res As Integer = wclNetworkListManager.GetNetwork(New Guid(lvNetworks.SelectedItems(0).SubItems(0).Text), Network)
        If Not ShowError(Res) Then
            If ShowError(Network.SetCategory(CType(cbCategory.SelectedIndex, wclWiFi.wclNlmNetworkCategory))) Then
                MessageBox.Show("Admin privilegies required")

                Network = Nothing
            End If
        End If
    End Sub

    Private Sub ShowConnections(ByRef Connections() As wclWiFi.wclNlmConnection)
        lvConnections.Items.Clear()

        If Connections Is Nothing Then
            Return
        End If

        Try
            Dim i As Integer
            For i = 0 To Connections.Length - 1
                Dim Connection As wclWiFi.wclNlmConnection = Connections(i)
                Dim Item As ListViewItem = lvConnections.Items.Add("")

                Dim Id As Guid
                Dim Res As Integer = Connection.GetAdapterId(Id)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.Text = Id.ToString()
                Else
                    Item.Text = "Error: 0x" + Res.ToString("X8")
                End If

                Dim Connected As Boolean
                Res = Connection.GetConnected(Connected)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems.Add(Connected.ToString())
                Else
                    Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                End If

                Res = Connection.GetConnectedToInternet(Connected)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems.Add(Connected.ToString())
                Else
                    Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                End If

                Dim Connectivity As wclWiFi.wclNlmConnectivity
                Res = Connection.GetConnectivity(Connectivity)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems.Add(Connectivity.ToString())
                Else
                    Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                End If

                Dim Domain As wclWiFi.wclNlmDomainType
                Res = Connection.GetDomainType(Domain)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems.Add(Domain.ToString())
                Else
                    Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                End If

                Res = Connection.GetId(Id)
                If Res = wclCommon.wclErrors.WCL_E_SUCCESS Then
                    Item.SubItems.Add(Id.ToString())
                Else
                    Item.SubItems.Add("Error: 0x" + Res.ToString("X8"))
                End If
            Next i
        Finally
            Connections = Nothing
        End Try
    End Sub

    Private Sub btGetMachineConnections_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetMachineConnections.Click
        Dim Connections() As wclWiFi.wclNlmConnection = Nothing
        If Not ShowError(wclNetworkListManager.GetConnections(Connections)) Then
            ShowConnections(Connections)
        End If
    End Sub

    Private Sub btDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btDelete.Click
        If lvNetworks.SelectedItems.Count = 0 Then
            MessageBox.Show("Select network")
            Return
        End If

        Dim Res As Integer = wclNetworkListManager.DeleteNetwork(New Guid(lvNetworks.SelectedItems(0).SubItems(0).Text))
        If Not ShowError(Res) Then
            lvNetworks.Items.Remove(lvNetworks.SelectedItems(0))
        End If
    End Sub
End Class
