Public Class fmMain
    Private WithEvents wclSoftAP As wclWiFi.wclWiFiSoftAP

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        wclSoftAP = New wclWiFi.wclWiFiSoftAP()
    End Sub

    Private Sub wclSoftAP_OnDeviceAccept(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByRef Accept As Boolean) Handles wclSoftAP.OnDeviceAccept
        Accept = MessageBox.Show("Accept device: " + Device.Id, "Accept", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes
    End Sub

    Private Sub wclSoftAP_OnDeviceConnected(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice) Handles wclSoftAP.OnDeviceConnected
        lbLog.Items.Add("Device Connected " + Device.Name)
        lbLog.Items.Add("  Local IP: " + Device.LocalAddress)
        lbLog.Items.Add("  Remote IP: " + Device.RemoteAddress)
    End Sub

    Private Sub wclSoftAP_OnDeviceConnectError(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice, ByVal [Error] As Integer) Handles wclSoftAP.OnDeviceConnectError
        lbLog.Items.Add("Device " + Device.Name + " connect error: " + [Error].ToString("X8"))
    End Sub

    Private Sub wclSoftAP_OnDeviceDisconnected(ByVal Sender As Object, ByVal Device As wclWiFi.wclWiFiDirectDevice) Handles wclSoftAP.OnDeviceDisconnected
        lbLog.Items.Add("Device Disconnected " + Device.Name)
        lbLog.Items.Add("  Local IP: " + Device.LocalAddress)
        lbLog.Items.Add("  Remote IP: " + Device.RemoteAddress)
    End Sub

    Private Sub wclSoftAP_OnStarted(ByVal sender As Object, ByVal e As System.EventArgs) Handles wclSoftAP.OnStarted
        lbLog.Items.Add("Started")

        Dim Str As String = ""
        Dim Res As Int32 = wclSoftAP.GetSsid(Str)
        If Res <> wclCommon.wclErrors.WCL_E_SUCCESS Then
            Str = "Error 0x" + Res.ToString("X8")
        End If
        lbLog.Items.Add("SSID: " + Str)

        Res = wclSoftAP.GetPassphrase(Str)
        If Res <> wclCommon.wclErrors.WCL_E_SUCCESS Then
            Str = "Error 0x" + Res.ToString("X8")
        End If
        lbLog.Items.Add("Passphrase: " + Str)
    End Sub

    Private Sub wclSoftAP_OnStopped(ByVal sender As Object, ByVal e As System.EventArgs) Handles wclSoftAP.OnStopped
        lbLog.Items.Add("Stopped")
    End Sub

    Private Sub btStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStart.Click
        Dim Res As Int32 = wclSoftAP.Start(edSsid.Text, edPassphrase.Text)
        lbLog.Items.Add("Started 0x" + Res.ToString("X8"))
    End Sub

    Private Sub btStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStop.Click
        Dim Res As Int32 = wclSoftAP.Stop()
        lbLog.Items.Add("Stop 0x" + Res.ToString("X8"))
    End Sub

    Private Sub fmMain_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        wclSoftAP.Stop()
    End Sub

    Private Sub btGetIpSettings_Click(sender As System.Object, e As System.EventArgs) Handles btGetIpSettings.Click
        Dim Address As String = ""
        Dim Mask As String = ""
        Dim Gateway As String = ""
        Dim Dns1 As String = ""
        Dim Dns2 As String = ""
        Dim Res As Integer = wclSoftAP.GetIpSettings(Address, Mask, Gateway, Dns1, Dns2)
        If Res <> wclErrors.WCL_E_SUCCESS Then
            lbLog.Items.Add("Read IP settings failed: 0x" + Res.ToString("X8"))
        Else
            lbLog.Items.Add("IP settings:")
            lbLog.Items.Add("  Address: " + Address)
            lbLog.Items.Add("  Mask: " + Mask)
            lbLog.Items.Add("  Gateway: " + Gateway)
            lbLog.Items.Add("  Dns1: " + Dns1)
            lbLog.Items.Add("  Dns2: " + Dns2)
        End If
    End Sub

    Private Sub btSetIpSettings_Click(sender As System.Object, e As System.EventArgs) Handles btSetIpSettings.Click
        Dim Res As Integer = wclSoftAP.SetIpSettings("192.168.2.10", "255.255.255.0", "192.168.2.1", "", "")
        If Res <> wclErrors.WCL_E_SUCCESS Then
            lbLog.Items.Add("Write IP settings failed: 0x" + Res.ToString("X8"))
        End If
    End Sub

    Private Sub btResetIpSettings_Click(sender As System.Object, e As System.EventArgs) Handles btResetIpSettings.Click
        Dim Res As Integer = wclSoftAP.ResetIpSettings()
        If Res <> wclErrors.WCL_E_SUCCESS Then
            lbLog.Items.Add("Reset IP settings failed: 0x" + Res.ToString("X8"))
        End If
    End Sub
End Class
