Public Class fmMain
    Private WithEvents WiFiEvents As wclWiFi.wclWiFiEvents
    Private WithEvents FPowerMonitor As wclCommon.wclPowerEventsMonitor

    Private Sub fmMain_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        WiFiEvents.Close()

        FPowerMonitor.Close()
    End Sub

    Private Sub fmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        WiFiEvents = New wclWiFi.wclWiFiEvents()

        FPowerMonitor = New wclCommon.wclPowerEventsMonitor()
        FPowerMonitor.Open()
    End Sub

    Private Sub WiFiEvents_AfterOpen(ByVal sender As Object, ByVal e As System.EventArgs) Handles WiFiEvents.AfterOpen
        TraceEvent(Guid.Empty, "AfterOpen", "", "")
    End Sub

    Private Sub WiFiEvents_BeforeClose(ByVal sender As Object, ByVal e As System.EventArgs) Handles WiFiEvents.BeforeClose
        TraceEvent(Guid.Empty, "BeforeClose", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmAdHocNetworkStateChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal State As wclWiFi.wclWiFiAdHocNetworkState) Handles WiFiEvents.OnAcmAdHocNetworkStateChange
        TraceEvent(IfaceId, "AcmAdHocNetworkStateChange", "State", State.ToString())
    End Sub

    Private Sub WiFiEvents_OnAcmAutoconfDisabled(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmAutoconfDisabled
        TraceEvent(IfaceId, "AcmAutoconfDisabled", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmAutoconfEnabled(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmAutoconfEnabled
        TraceEvent(IfaceId, "AcmAutoconfEnabled", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmBackgroundScanDisabled(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmBackgroundScanDisabled
        TraceEvent(IfaceId, "AcmBackgroundScanDisabled", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmBackgroundScanEnabled(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmBackgroundScanEnabled
        TraceEvent(IfaceId, "AcmBackgroundScanEnabled", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmBssTypeChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal BssType As wclWiFi.wclWiFiBssType) Handles WiFiEvents.OnAcmBssTypeChange
        TraceEvent(IfaceId, "AcmBssTypeChange", "BSS type", BssType.ToString())
    End Sub

    Private Sub WiFiEvents_OnAcmConnectionAttemptFail(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiAcmConnectionEventData) Handles WiFiEvents.OnAcmConnectionAttemptFail
        TraceAcmConnectionEvent(IfaceId, "AcmConnectionAttemptFail", Data)
    End Sub

    Private Sub WiFiEvents_OnAcmConnectionComplete(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiAcmConnectionEventData) Handles WiFiEvents.OnAcmConnectionComplete
        TraceAcmConnectionEvent(IfaceId, "AcmConnectionComplete", Data)
    End Sub

    Private Sub WiFiEvents_OnAcmConnectionStart(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiAcmConnectionEventData) Handles WiFiEvents.OnAcmConnectionStart
        TraceAcmConnectionEvent(IfaceId, "AcmConnectionStart", Data)
    End Sub

    Private Sub WiFiEvents_OnAcmDisconnected(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiAcmConnectionEventData) Handles WiFiEvents.OnAcmDisconnected
        TraceAcmConnectionEvent(IfaceId, "AcmDisconnected", Data)
    End Sub

    Private Sub WiFiEvents_OnAcmDisconnecting(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiAcmConnectionEventData) Handles WiFiEvents.OnAcmDisconnecting
        TraceAcmConnectionEvent(IfaceId, "AcmDisconnecting", Data)
    End Sub

    Private Sub WiFiEvents_OnAcmFilterListChange(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmFilterListChange
        TraceEvent(IfaceId, "AcmFilterListChange", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmInterfaceArrival(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmInterfaceArrival
        TraceEvent(IfaceId, "AcmInterfaceArrival", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmInterfaceRemoval(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmInterfaceRemoval
        TraceEvent(IfaceId, "AcmInterfaceRemoval", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmNetworkAvailable(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmNetworkAvailable
        TraceEvent(IfaceId, "AcmNetworkAvailable", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmNetworkNotAvailable(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmNetworkNotAvailable
        TraceEvent(IfaceId, "AcmNetworkNotAvailable", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmOperationalStateChange(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmOperationalStateChange
        TraceEvent(IfaceId, "AcmOperationalStateChange", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmPowerSettingChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Setting As wclWiFi.wclWiFiPowerSetting) Handles WiFiEvents.OnAcmPowerSettingChange
        TraceEvent(IfaceId, "AcmOperationalStateChange", "Setting", Setting.ToString())
    End Sub

    Private Sub WiFiEvents_OnAcmProfileBlocked(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmProfileBlocked
        TraceEvent(IfaceId, "AcmProfileBlocked", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmProfileChange(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmProfileChange
        TraceEvent(IfaceId, "AcmProfileChange", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmProfileNameChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal OldName As String, ByVal NewName As String) Handles WiFiEvents.OnAcmProfileNameChange
        TraceEvent(IfaceId, "AcmProfileNameChange", "OldName", OldName)
        TraceEvent(Guid.Empty, "", "NewName", NewName)
    End Sub

    Private Sub WiFiEvents_OnAcmProfilesExhausted(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmProfilesExhausted
        TraceEvent(IfaceId, "AcmProfilesExhausted", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmProfileUnblocked(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmProfileUnblocked
        TraceEvent(IfaceId, "AcmProfileUnblocked", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmScanComplete(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmScanComplete
        TraceEvent(IfaceId, "AcmScanComplete", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmScanFail(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Reason As Integer) Handles WiFiEvents.OnAcmScanFail
        TraceEvent(IfaceId, "AcmScanFail", "Reason", "0x" + Reason.ToString("X8"))
    End Sub

    Private Sub WiFiEvents_OnAcmScanListRefresh(ByVal Sender As Object, ByVal IfaceId As System.Guid) Handles WiFiEvents.OnAcmScanListRefresh
        TraceEvent(IfaceId, "AcmScanListRefresh", "", "")
    End Sub

    Private Sub WiFiEvents_OnAcmScreenPowerChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal SwitchedOn As Boolean) Handles WiFiEvents.OnAcmScreenPowerChange
        TraceEvent(IfaceId, "AcmScreenPowerChange", "SwitchedOn", SwitchedOn.ToString())
    End Sub

    Private Sub WiFiEvents_OnHostedNetworkPeerStateChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal OldState As wclWiFi.wclWiFiHostedNetworkPeerState, ByVal NewState As wclWiFi.wclWiFiHostedNetworkPeerState, ByVal Reason As Integer) Handles WiFiEvents.OnHostedNetworkPeerStateChange
        TraceEvent(IfaceId, "HostedNetworkPeerStateChange", "Old MAC", OldState.Mac)
        TraceEvent(Guid.Empty, "", "Old authentication state", OldState.AuthState.ToString())
        TraceEvent(Guid.Empty, "", "New MAC", NewState.Mac)
        TraceEvent(Guid.Empty, "", "New authentication state", NewState.AuthState.ToString())
        TraceEvent(Guid.Empty, "", "Reason", "0x" + Reason.ToString("X8"))
    End Sub

    Private Sub WiFiEvents_OnHostedNetworkRadioStateChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal SoftwareState As wclWiFi.wclWiFiRadioState, ByVal HardwareState As wclWiFi.wclWiFiRadioState) Handles WiFiEvents.OnHostedNetworkRadioStateChange
        TraceEvent(IfaceId, "HostedNetworkRadioStateChange", "Software state", SoftwareState.ToString())
        TraceEvent(Guid.Empty, "", "Hardware state", HardwareState.ToString())
    End Sub

    Private Sub WiFiEvents_OnHostedNetworkStateChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal OldState As wclWiFi.wclWiFiHostedNetworkState, ByVal NewState As wclWiFi.wclWiFiHostedNetworkState, ByVal Reason As Integer) Handles WiFiEvents.OnHostedNetworkStateChange
        TraceEvent(IfaceId, "HostedNetworkStateChange", "Old state", OldState.ToString())
        TraceEvent(Guid.Empty, "", "New state", NewState.ToString())
        TraceEvent(Guid.Empty, "", "Reason", "0x" + Reason.ToString("X8"))
    End Sub

    Private Sub WiFiEvents_OnIpChanged(Sender As Object, IfaceId As System.Guid, Old As wclWiFi.wclWiFiIpSettings, [New] As wclWiFi.wclWiFiIpSettings) Handles WiFiEvents.OnIpChanged
        TraceEvent(IfaceId, "IP changed", "Old address", Old.Address)
        TraceEvent(Guid.Empty, "IP changed", "New address", [New].Address)
    End Sub

    Private Sub WiFiEvents_OnMsmAdapterOperationModeChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Mode As wclWiFi.wclWiFiOperationMode) Handles WiFiEvents.OnMsmAdapterOperationModeChange
        TraceEvent(IfaceId, "MsmAdapterOperationModeChange", "Mode", Mode.ToString())
    End Sub

    Private Sub WiFiEvents_OnMsmAdapterRemoval(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmAdapterRemoval
        TraceMsmConnectionEvent(IfaceId, "MsmAdapterRemoval", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmAssociated(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmAssociated
        TraceMsmConnectionEvent(IfaceId, "MsmAssociated", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmAssociating(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmAssociating
        TraceMsmConnectionEvent(IfaceId, "MsmAssociating", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmAuthenticating(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmAuthenticating
        TraceMsmConnectionEvent(IfaceId, "MsmAuthenticating", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmConnected(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmConnected
        TraceMsmConnectionEvent(IfaceId, "MsmConnected", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmDisassociating(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmDisassociating
        TraceMsmConnectionEvent(IfaceId, "MsmDisassociating", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmDisconnected(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmDisconnected
        TraceMsmConnectionEvent(IfaceId, "MsmDisconnected", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmLinkDegraded(Sender As Object, IfaceId As System.Guid) Handles WiFiEvents.OnMsmLinkDegraded
        TraceEvent(IfaceId, "MsmLinkDegraded", "", "")
    End Sub

    Private Sub WiFiEvents_OnMsmLinkImproved(Sender As Object, IfaceId As System.Guid) Handles WiFiEvents.OnMsmLinkImproved
        TraceEvent(IfaceId, "MsmLinkImproved", "", "")
    End Sub

    Private Sub WiFiEvents_OnMsmPeerJoin(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmPeerJoin
        TraceMsmConnectionEvent(IfaceId, "MsmPeerJoin", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmPeerLeave(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmPeerLeave
        TraceMsmConnectionEvent(IfaceId, "MsmPeerLeave", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmRadioStateChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal State As wclWiFi.wclWiFiPhyRadioState) Handles WiFiEvents.OnMsmRadioStateChange
        TraceEvent(IfaceId, "MsmRadioStateChange", "PHY", State.Phy.ToString())
        TraceEvent(Guid.Empty, "", "Software state", State.SoftwareState.ToString())
        TraceEvent(Guid.Empty, "", "Hardware state", State.HardwareState.ToString())
    End Sub

    Private Sub WiFiEvents_OnMsmRoamingEnd(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmRoamingEnd
        TraceMsmConnectionEvent(IfaceId, "MsmRoamingEnd", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmRoamingStart(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData) Handles WiFiEvents.OnMsmRoamingStart
        TraceMsmConnectionEvent(IfaceId, "MsmRoamingStart", Data)
    End Sub

    Private Sub WiFiEvents_OnMsmSignalQualityChange(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Quality As UInteger) Handles WiFiEvents.OnMsmSignalQualityChange
        TraceEvent(IfaceId, "MsmSignalQualityChange", "Quality", Quality.ToString())
    End Sub

    Private Sub WiFiEvents_OnOneXAuthRestarted(ByVal Sender As Object, ByVal IfaceId As System.Guid, ByVal Reason As Integer) Handles WiFiEvents.OnOneXAuthRestarted
        TraceEvent(IfaceId, "OneXAuthRestarted", "Reason", "0x" + Reason.ToString("X8"))
    End Sub

    Private Sub TraceMsmConnectionEvent(ByVal IfaceId As Guid, ByVal EventName As String, ByVal Data As wclWiFi.wclWiFiMsmConnectionEventData)
        TraceEvent(IfaceId, EventName, "ConnectionMode", Data.ConnectionMode.ToString())
        TraceEvent(Guid.Empty, "", "Profile name", Data.ProfileName)
        TraceEvent(Guid.Empty, "", "SSID", Data.Ssid)
        TraceEvent(Guid.Empty, "", "BSS type", Data.BssType.ToString())
        TraceEvent(Guid.Empty, "", "MAC", Data.Mac)
        TraceEvent(Guid.Empty, "", "Security enabled", Data.SecurityEnabled.ToString())
        TraceEvent(Guid.Empty, "", "First peer", Data.FirstPeer.ToString())
        TraceEvent(Guid.Empty, "", "Last peer", Data.LastPeer.ToString())
        TraceEvent(Guid.Empty, "", "Reason", "0x" + Data.Reason.ToString("X8"))
    End Sub

    Private Sub TraceAcmConnectionEvent(ByVal IfaceId As Guid, ByVal EventName As String, ByVal Data As wclWiFi.wclWiFiAcmConnectionEventData)
        TraceEvent(IfaceId, EventName, "ConnectionMode", Data.ConnectionMode.ToString())
        TraceEvent(Guid.Empty, "", "Profile name", Data.ProfileName)
        TraceEvent(Guid.Empty, "", "SSID", Data.Ssid)
        TraceEvent(Guid.Empty, "", "BSS type", Data.BssType.ToString())
        TraceEvent(Guid.Empty, "", "Security enabled", Data.SecurityEnabled.ToString())
        TraceEvent(Guid.Empty, "", "Reason", "0x" + Data.Reason.ToString("X8"))
        TraceEvent(Guid.Empty, "", "Flags", Data.Flags.ToString())
        TraceEvent(Guid.Empty, "", "Profile XML", Data.ProfileXml)
    End Sub

    Private Sub btEventsOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btEventsOpen.Click
        ShowResult(WiFiEvents.Open())
    End Sub

    Private Sub btEventsClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btEventsClose.Click
        ShowResult(WiFiEvents.Close())
    End Sub

    Private Sub ShowResult(ByVal Res As Int32)
        If Res <> wclCommon.wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Error: 0x" + Res.ToString("X8"))
        End If
    End Sub

    Private Sub btEventsClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btEventsClear.Click
        lvEvents.Items.Clear()
    End Sub

    Private Sub TraceEvent(ByVal Iface As Guid, ByVal EventName As String, ByVal ParamName As String, ByVal ParamValue As String)
        Dim Id As String
        If Iface = Guid.Empty Then
            Id = ""
        Else
            Id = Iface.ToString()
        End If

        Dim Item As ListViewItem = lvEvents.Items.Add(Id)
        Item.SubItems.Add(EventName)
        Item.SubItems.Add(ParamName)
        Item.SubItems.Add(ParamValue)
    End Sub

    Private Sub FPowerMonitor_OnPowerStateChanged(Sender As Object, State As wclCommon.wclPowerState) Handles FPowerMonitor.OnPowerStateChanged
        Select State
            Case wclCommon.wclPowerState.psResumeAutomatic
                TraceEvent(Guid.Empty, "Power", "State", "psResumeAutomatic")
            Case wclCommon.wclPowerState.psResume
                TraceEvent(Guid.Empty, "Power", "State", "psResume")
            Case wclCommon.wclPowerState.psSuspend
                TraceEvent(Guid.Empty, "Power", "State", "psSuspend")
            Case wclCommon.wclPowerState.psUnknown
                TraceEvent(Guid.Empty, "Power", "State", "psUnknown")
        End Select
    End Sub

    Private Sub WiFiEvents_OnOneXAuthUpdate(Sender As Object, IfaceId As System.Guid, State As wclWiFi.wclWiFiOneXStatusUpdate) Handles WiFiEvents.OnOneXAuthUpdate
        Dim Str As String

        Select State.Status.Status
            Case wclWiFi.wclWiFiOneXAuthStatus.oxAuthNotStarted
                Str = "oxAuthNotStarted"
            Case wclWiFi.wclWiFiOneXAuthStatus.oxAuthInProgress
                Str = "oxAuthInProgress"
            Case wclWiFi.wclWiFiOneXAuthStatus.oxAuthNoAuthenticatorFound
                Str = "oxAuthNoAuthenticatorFound"
            Case wclWiFi.wclWiFiOneXAuthStatus.oxAuthSuccess
                Str = "oxAuthSuccess"
            Case wclWiFi.wclWiFiOneXAuthStatus.oxAuthFailure
                Str = "oxAuthFailure"
            Case wclWiFi.wclWiFiOneXAuthStatus.oxAuthInvalid
                Str = "oxAuthInvalid"
            Case Else
                Str = ""
        End Select
        TraceEvent(IfaceId, "OneXAuthUpdate", "Status", Str)
        TraceEvent(Guid.Empty, "", "Status.Reason", "0x" + State.Status.Reason.ToString("X8"))
        TraceEvent(Guid.Empty, "", "Status.Error", "0x" + State.Status.Error.ToString("X8"))

        Select State.BackendSupport
            Case wclWiFi.wclWiFiOneXEapMethodBackendSupport.oxEapMethodBackendSupportUnknown
                Str = "oxEapMethodBackendSupportUnknown"
            Case wclWiFi.wclWiFiOneXEapMethodBackendSupport.oxEapMethodBackendSupported
                Str = "oxEapMethodBackendSupported"
            Case wclWiFi.wclWiFiOneXEapMethodBackendSupport.oxEapMethodBackendUnsupported
                Str = "oxEapMethodBackendUnsupported"
            Case Else
                Str = ""
        End Select
        TraceEvent(Guid.Empty, "", "BackendSupport", Str)

        If State.BackendEngaged Then
            TraceEvent(Guid.Empty, "", "BackendEngaged", "True")
        Else
            TraceEvent(Guid.Empty, "", "BackendEngaged", "False")
        End If

        If State.AuthParams.UpdatePending Then
            TraceEvent(Guid.Empty, "", "AuthParams.UpdatePending", "True")
        Else
            TraceEvent(Guid.Empty, "", "AuthParams.UpdatePending", "False")
        End If

        Select State.AuthParams.Profile.SupplicantMode
            Case wclWiFi.wclWiFiOneXSupplicantMode.oxSupplicantModeInhibitTransmission
                Str = "oxSupplicantModeInhibitTransmission"
            Case wclWiFi.wclWiFiOneXSupplicantMode.oxSupplicantModeLearn
                Str = "oxSupplicantModeLearn"
            Case wclWiFi.wclWiFiOneXSupplicantMode.oxSupplicantModeCompliant
                Str = "oxSupplicantModeCompliant"
            Case wclWiFi.wclWiFiOneXSupplicantMode.oxSupplicantModeInvalid
                Str = "oxSupplicantModeInvalid"
            Case Else
                Str = ""
        End Select
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.SupplicantMode", Str)

        Select State.AuthParams.Profile.AuthMode
            Case wclWiFi.wclWiFiOnexXAuthMode.oxAuthModeMachineOrUser
                Str = "oxAuthModeMachineOrUser"
            Case wclWiFi.wclWiFiOnexXAuthMode.oxAuthModeMachineOnly
                Str = "oxAuthModeMachineOnly"
            Case wclWiFi.wclWiFiOnexXAuthMode.oxAuthModeUserOnly
                Str = "oxAuthModeUserOnly"
            Case wclWiFi.wclWiFiOnexXAuthMode.oxAuthModeGuest
                Str = "oxAuthModeGuest"
            Case wclWiFi.wclWiFiOnexXAuthMode.oxAuthModeUnspecified
                Str = "oxAuthModeUnspecified"
            Case wclWiFi.wclWiFiOnexXAuthMode.oxAuthModeInvalid
                Str = "oxAuthModeInvalid"
            Case Else
                Str = ""
        End Select
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.AuthMode", Str)

        TraceEvent(Guid.Empty, "", "AuthParams.Profile.HeldPeriod", State.AuthParams.Profile.HeldPeriod.ToString())
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.AuthPeriod", State.AuthParams.Profile.AuthPeriod.ToString())
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.StartPeriod", State.AuthParams.Profile.StartPeriod.ToString())
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.MaxStart", State.AuthParams.Profile.MaxStart.ToString())
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.MaxAuthFailures", State.AuthParams.Profile.MaxAuthFailures.ToString())
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.NetworkAuthTimeout", State.AuthParams.Profile.NetworkAuthTimeout.ToString())
        TraceEvent(Guid.Empty, "", "AuthParams.Profile.NetworkAuthWithUITimeout", State.AuthParams.Profile.NetworkAuthWithUITimeout.ToString())

        If State.AuthParams.Profile.AllowLogonDialogs Then
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.AllowLogonDialogs", "True")
        Else
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.AllowLogonDialogs", "False")
        End If

        If State.AuthParams.Profile.UserBasedVLan Then
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.UserBasedVLan", "True")
        Else
            TraceEvent(Guid.Empty, "", "AuthParams.Profile.UserBasedVLan", "False")
        End If

        Select State.AuthParams.AuthIdentity
            Case wclWiFi.wclWiFiOneXAuthIdentity.oxAuthIdentityNone
                Str = ""
            Case wclWiFi.wclWiFiOneXAuthIdentity.oxAuthIdentityMachine
                Str = ""
            Case wclWiFi.wclWiFiOneXAuthIdentity.oxAuthIdentityUser
                Str = ""
            Case wclWiFi.wclWiFiOneXAuthIdentity.oxAuthIdentityExplicitUser
                Str = ""
            Case wclWiFi.wclWiFiOneXAuthIdentity.oxAuthIdentityGuest
                Str = ""
            Case wclWiFi.wclWiFiOneXAuthIdentity.oxAuthIdentityInvalid
                Str = ""
            Case wclWiFi.wclWiFiOneXAuthIdentity.oxAuthIdentityUnknown
                Str = ""
            Case Else
                Str = ""
        End Select
        TraceEvent(Guid.Empty, "", "AuthParams.AuthIdentity", Str)

        Select Case State.AuthParams.QuarantineState
            Case wclWiFi.wclWiFiIsolationState.isUnknonw
                Str = "isUnknonw"
            Case wclWiFi.wclWiFiIsolationState.isNotRestricted
                Str = "isNotRestricted"
            Case wclWiFi.wclWiFiIsolationState.isInProbation
                Str = "isInProbation"
            Case wclWiFi.wclWiFiIsolationState.isRestrictedAccess
                Str = "isRestrictedAccess"
            Case wclWiFi.wclWiFiIsolationState.isInvalid
                Str = "isInvalid"
            Case Else
                Str = ""
        End Select
        TraceEvent(Guid.Empty, "", "AuthParams.QuarantineState", Str)

        TraceEvent(Guid.Empty, "", "AuthParams.SessiondId", State.AuthParams.SessiondId.ToString())
        TraceEvent(Guid.Empty, "", "AuthParams.Identity", State.AuthParams.Identity)
        TraceEvent(Guid.Empty, "", "AuthParams.UserName", State.AuthParams.UserName)
        TraceEvent(Guid.Empty, "", "AuthParams.Domain", State.AuthParams.Domain)

        TraceEvent(Guid.Empty, "", "EapError.Error", "0x" + State.EapError.Error.ToString("X8"))

        TraceEvent(Guid.Empty, "", "EapError.MethodType.EapType.EapType", State.EapError.MethodType.EapType.EapType.ToString())
        TraceEvent(Guid.Empty, "", "EapError.MethodType.EapType.VendorId", State.EapError.MethodType.EapType.VendorId.ToString())
        TraceEvent(Guid.Empty, "", "EapError.MethodType.EapType.VendorType", State.EapError.MethodType.EapType.VendorType.ToString())

        TraceEvent(Guid.Empty, "", "EapError.MethodType.AuthorId", State.EapError.MethodType.AuthorId.ToString())

        TraceEvent(Guid.Empty, "", "EapError.Reason", "0x" + State.EapError.Reason.ToString("X8"))
        TraceEvent(Guid.Empty, "", "EapError.RootCauseGuid", State.EapError.RootCauseGuid.ToString())
        TraceEvent(Guid.Empty, "", "EapError.RepairGuid", State.EapError.RepairGuid.ToString())
        TraceEvent(Guid.Empty, "", "EapError.HelpLinkGuid", State.EapError.HelpLinkGuid.ToString())
        TraceEvent(Guid.Empty, "", "EapError.RootCauseString", State.EapError.RootCauseString)
        TraceEvent(Guid.Empty, "", "EapError.RepairString", State.EapError.RepairString)
    End Sub
End Class
